#include "MainHeader.h"
//Get the Major Arrays
//Currently only one exists
int GetArrays(){
	int i=0,ii=0;;
	u32 myoffset=0x833DFDC;
	
	/*
	Get FileNo, HeaderPointers + 1, RoomOffsets
	Get FileNo, DoorPointers + 1, DoorOffsets
	Get FileNo, SpecialEffectTablePnt + 1, SpecialEffects
	Get FileNo, MiniMapBanks + 1, ZMMiniMapOffsets()
	Get FileNo, ZMScrollListBase + 1, ZMScrolls()
	*/
	memset(&RoomTilesets,0,0x500);
	fclose(GBA.ROM);
	fopen(GBA.FileLoc,"r+b");
	fseek(GBA.ROM, myoffset-0x8000000,SEEK_SET);//Tileset
	ii=GetLastError();
	for( i=0;i<0x50;i++){
		fread(&RoomTilesets[i].gTiles,4,1,GBA.ROM);
		
		fread(&RoomTilesets[i].pTiles,4,1,GBA.ROM);
		fread(&RoomTilesets[i].gBackground,4,1,GBA.ROM);
		fread(&RoomTilesets[i].TSAMap,4,1,GBA.ROM);
		fread(&RoomTilesets[i].EffectSet,4,1,GBA.ROM);  
   	}
	
    fseek(GBA.ROM,0x75FD28,SEEK_SET);
	for( i = 0; i < 0xB;i++) fread(&ZMScrolls[i],4,1,GBA.ROM);
	fseek(GBA.ROM, 0x75FAC4,SEEK_SET);
	fread(RoomOffsets,sizeof(long),7,GBA.ROM);
	fseek(GBA.ROM,0x75FAA8,SEEK_SET);
	fread(DoorOffsets,sizeof(long),7,GBA.ROM);
	
	return 0;
}

int GetMFArrays(){
	int i=0;
	/*
	Get FileNo, HeaderPointers + 1, RoomOffsets
	Get FileNo, DoorPointers + 1, DoorOffsets
	Get FileNo, SpecialEffectTablePnt + 1, SpecialEffects
	Get FileNo, MiniMapBanks + 1, ZMMiniMapOffsets()
	Get FileNo, ZMScrollListBase + 1, ZMScrolls()
	   MFTileSetHeaders = &H3BF888
    MFHeaderPointers = &H79B8BC
    MFLookUpTable = &H3C8F90
    ReDim DoorOffsets(0 To 9) As Long
    DoorPointers = &H79B894
    MFSpecialEffectTablePnt = &H3C8D58
    MFScrollListBase = &H79BB08
    Enableit*/
	fseek(GBA.ROM,0x2E4A50,SEEK_SET);
	fread(&MFSprSize,4,0xC0,GBA.ROM);
	fseek(GBA.ROM, 0x3BF888,SEEK_SET);//Tileset
	for(i=0;i<0x70;i++){
		fread(&MFRoomTilesets[i].gTiles,sizeof(long),1,GBA.ROM);
		fread(&MFRoomTilesets[i].pTiles,sizeof(long),1,GBA.ROM);
		fread(&MFRoomTilesets[i].gBackground,sizeof(long),1,GBA.ROM);
		fread(&MFRoomTilesets[i].TSAMap,sizeof(long),1,GBA.ROM);
		fread(&MFRoomTilesets[i].EffectSet,sizeof(long),1,GBA.ROM);  
   	}
	
	fseek(GBA.ROM,0x79BB08,SEEK_SET);
	for(i = 0; i < 0xB;i++) fread(&MFScrolls[i],4,1,GBA.ROM);
	fseek(GBA.ROM, 0x79B8BC,SEEK_SET);
	fread(MFRoomOffsets,4,10,GBA.ROM);
	fseek(GBA.ROM,0x79B894,SEEK_SET);
	fread(MFDoorOffsets,4,10,GBA.ROM);
	fseek(GBA.ROM,0x3e419c,SEEK_SET);
	fread(&VRAM.RAM[0x900],1,0x36E0,GBA.ROM);
	fseek(GBA.ROM,0x58b466,SEEK_SET);
	fread(&GBASprPal[0x40],1,0x14,GBA.ROM);
	fseek(GBA.ROM,0x3E40F2,SEEK_SET);
	fread(&GBASprPal[0x56],1,0x3E,GBA.ROM);
    
	return 0;
}
/*int LoadRoom(){
int Room = */

int LoadHeader(long Offset){
	long blah=0;
	int BGi=0;
	fseek(GBA.ROM,Offset,SEEK_SET);
	fread(&RoomHeader.bTileset,sizeof(u8),1,GBA.ROM);
	fread(&RoomHeader.bBg0,sizeof(u8),1,GBA.ROM);
	fread(&RoomHeader.bBg1,sizeof(u8),1,GBA.ROM);
	fread(&RoomHeader.bBg2,sizeof(u8),1,GBA.ROM);
	fread(&RoomHeader.lBg3,sizeof(u32),1,GBA.ROM);
	fread(&RoomHeader.lForeground,sizeof(u32),1,GBA.ROM); 
	fread(&RoomHeader.lLevelData,sizeof(u32),1,GBA.ROM);
	fread(&RoomHeader.lBackLayer,sizeof(u32),1,GBA.ROM);
	fread(&RoomHeader.lClipData,sizeof(u32),1,GBA.ROM); 
	fread(&RoomHeader.lBackgroundTSA,sizeof(u32),1,GBA.ROM);
	fread(&RoomHeader.bUnknown1,sizeof(u8),1,GBA.ROM);
	fread(&RoomHeader.TransForeground,sizeof(u8),1,GBA.ROM);
	fread(&RoomHeader.iSep1,sizeof(u16),1,GBA.ROM);
	fread(&RoomHeader.lSpritePointer,sizeof(u32),1,GBA.ROM); 
	fread(&RoomHeader.bSpriteIndex1,sizeof(u8),1,GBA.ROM);
	fread(&RoomHeader.bEventSwitch,sizeof(u8),1,GBA.ROM);
	fread(&RoomHeader.iSep2,sizeof(u16),1,GBA.ROM);
	fread(&RoomHeader.lSpritePointer2,sizeof(u32),1,GBA.ROM); 
	fread(&RoomHeader.bSpriteIndex2,sizeof(u8),1,GBA.ROM);
	fread(&RoomHeader.bEventSwitch2,sizeof(u8),1,GBA.ROM);
	fread(&RoomHeader.iSeperator,sizeof(u16),1,GBA.ROM);
	fread(&RoomHeader.lSpritePointer3,sizeof(u32),1,GBA.ROM); 
	fread(&RoomHeader.bSpriteIndex3,sizeof(u8),1,GBA.ROM);
	blah=ftell(GBA.ROM)-Offset;
	fread(&RoomHeader.bMiniMapRoomX,sizeof(u8),1,GBA.ROM);
	fread(&RoomHeader.bMiniMapRoomY,sizeof(u8),1,GBA.ROM);
	fread(&RoomHeader.bEffect,sizeof(u8),1,GBA.ROM);
	fread(&RoomHeader.bSceneryYPos,sizeof(u8),1,GBA.ROM);
	fread(&RoomHeader.bNothing,sizeof(u8),1,GBA.ROM);
	fread(&RoomHeader.bMusic,sizeof(u8),1,GBA.ROM);
	fread(&RoomHeader.blank,sizeof(u8),1,GBA.ROM);
	CheckBoxes[Foreground].State(RoomHeader.bBg0==0x10);
	chkMC[0].State(RoomHeader.bBg0==0x10);
	CheckBoxes[Level].State(RoomHeader.bBg1==16);
	chkMC[1].State(RoomHeader.bBg1==16);
	CheckBoxes[Background].State(RoomHeader.bBg2==0x10);
    chkMC[2].State(RoomHeader.bBg2==0x10);
	EnableWindow(GetDlgItem(SceneWnd,cmdSEditForeground),(RoomHeader.bBg0==0x40 ? 1: 0));
	EnableWindow(GetDlgItem(SceneWnd,cmdSEditBack)      ,(RoomHeader.bBg2==0x40 ? 1: 0));
   	EnableWindow(GetDlgItem(SceneWnd,cmdSEditBG)        ,(RoomHeader.lBg3==0x40 ? 1: 0));
	CheckBoxes[ViewF].State(((RoomHeader.bBg0==0x10) || (RoomHeader.bBg0==0x40)));
	CheckBoxes[ViewL].State(RoomHeader.bBg1==16);
	CheckBoxes[ViewB].State(((RoomHeader.bBg2==0x10) || (RoomHeader.bBg2==0x40)));
	//CheckBoxes[viewBG].State((RoomHeader.lBg3==0x40) || (RoomHeader.lBg3==0xF0));
	CheckBoxes[ViewF].value(((RoomHeader.bBg0==0x10) || (RoomHeader.bBg0==0x40)));
	CheckBoxes[ViewL].value((RoomHeader.bBg1==16));
	CheckBoxes[ViewB].value(((RoomHeader.bBg2==0x10) || (RoomHeader.bBg2==0x40)));
    //CheckBoxes[viewBG].value((RoomHeader.lBg3==0x40) || (RoomHeader.lBg3==0xF0));
	//Check for BGi hack installed

	if((RoomHeader.bBg0==0x40) || (RoomHeader.bBg2==0x40) || (RoomHeader.lBg3==0x40||RoomHeader.lBg3==0xF0) || BGiInstall){
		EnableWindow(GetDlgItem(Main,cmdES),1);
    }else{
		EnableWindow(GetDlgItem(Main, cmdES),0);
	}
//	SetSceneControls();
	return 0;
}

int DrawLevel(){
	RECT rcMap;
	int i=0;
//	img[iRoom].Clear();
	for(i=0;i<2;i++){
	    CheckBoxes[ViewF].value(i);
		CheckBoxes[ViewL].value(i);
		CheckBoxes[ViewB].value(i);
		DrawRoom();
	}
	CurMapWidth = ThisLevelData.X;
	CurMapHeight =  ThisLevelData.Y;
	GetWindowRect(hwndMap,&rcMap);    
	nMaxHScroll[sHMap] = (ThisLevelData.X - (rcMap.right-rcMap.left)/16);//ThisLevelData.X/16;	// maximum H scroll
	nMaxVScroll[sVMap] = (ThisLevelData.Y - (rcMap.bottom-rcMap.top)/16 );		// maximu
	ChangeScrollbars(Main,1,sVMap);
	ChangeScrollbars(Main,0,sHMap);
	/*   frmMain.hsbMap.max = (ThisRoom.X) - 25
	frmMain.vsbMap.max = (ThisRoom.Y) - 17
	#define sHMap 1
#define sVMap 2*/
	InvalidateRect(hwndMap,0,1);
	//	rcMap.right = rcMap.right - rcMap.left;
	//	rcMap.bottom = rcMap.bottom - rcMap.top;
	//	CurMapWidth = (ThisLevelData.X<16 ? ThisLevelData.X*16:512);
	//	CurMapHeight = (ThisLevelData.Y<16 ? ThisLevelData.Y*16:512);
		  //   MoveWindow(hwndMap,0,0,CurMapWidth ,CurMapHeight,1);
	
	
	return 0;
}
int GetLayerData(u8 compression, u8 Layer, u32 offset){
nRoomBuff* ELayer[5]={	&ThisForeground,&ThisLevelData,&ThisBackLayer,&ThisBackground,&ThisClipData};//Edit Layer
fseek(GBA.ROM,offset,SEEK_SET);	
	if( compression == 0x10){
		fread(&ELayer[Layer]->X,sizeof(u8),1,GBA.ROM);		//ThisLevelData.X++;		// DISCH -- added inc
		fread(&ELayer[Layer]->Y,sizeof(u8),1,GBA.ROM);		//ThisLevelData.Y++;		// DISCH -- added inc
		// sprintf(buffer,"X is %x Y is %x",ThisLevelData.X,ThisLevelData.Y);
		// sMessage(buffer);
		fread(GBA.CompBuffer,sizeof(u8),64691,GBA.ROM);
		
		//GBA.ZMUncompRle(GBA.CompBuffer, (u8*)ThisLevelData.TileBuf2D ,ThisLevelData.X*ThisLevelData.Y, 1);
		ELayer[Layer]->BImage.Create(ELayer[Layer]->X*16,ELayer[Layer]->Y*16);
		ELayer[Layer]->BImage.SetPalette(PcPalMem);
		memset(ELayer[Layer]->TileBuf2D,0,0x20000);
		ELayer[Layer]->oSize=GBA.ZMUncompRle(ELayer[Layer]->X*ELayer[Layer]->Y, GBA.CompBuffer, (u8*)&ELayer[Layer]->TileBuf2D);
	}else if( compression==0x40){
        fseek(GBA.ROM,offset,SEEK_SET);	
		ELayer[Layer]->size=fgetc(GBA.ROM);
		
			if((ELayer[Layer]->size == 1)||(ELayer[Layer]->size >= 3)) {
				ELayer[Layer]->X = 64;
				ELayer[Layer]->Y = 32;
			}else if(ThisBackground.size == 2){
				ELayer[Layer]->X = 32;
				ELayer[Layer]->Y = 64;
			}else{
				
				ELayer[Layer]->X = 32; 
				ELayer[Layer]->Y = 32;
			}


		fseek(GBA.ROM,offset+4,SEEK_SET);
		fread(&GBA.CompBuffer,sizeof(u8),32691,GBA.ROM);
		memset(ELayer[Layer]->TileBuf2D,0,0x20000);
		//ThisBackLayer.oSize=GBA.LZ77UnComp(GBA.CompBuffer, decompbuf);
        ELayer[Layer]->oSize=GBA.LZ77UnComp(GBA.CompBuffer, (u8*)ELayer[Layer]->TileBuf2D);
		ELayer[Layer]->BImage.Create(1024,1024);
		ELayer[Layer]->BImage.SetPalette(PcPalMem);
		//memcpy(ELayer[Layer]->TileBuf2D,decompbuf,ELayer[Layer]->oSize);
	}
return 0;
}

int SaveLevel(FILE* fp, u32 HeaderOffset ){
	

//	GBA.REDIT = fopen(FilePath,"r+b");
	if(fp){
     //   while(1){ 
		GBA.ZMCompress(fp);
      //   if(RoomHeader.lBackLayer!=RoomHeader.lLevelData) break;
	//	}
	    SaveSprites();
		fseek(fp, HeaderOffset, SEEK_SET);
		
		
	
		fwrite(&RoomHeader.bTileset,sizeof(u8),1,fp);
		fwrite(&RoomHeader.bBg0,sizeof(u8),1,fp);
		fwrite(&RoomHeader.bBg1,sizeof(u8),1,fp);
		fwrite(&RoomHeader.bBg2,sizeof(u8),1,fp);
		fwrite(&RoomHeader.lBg3,sizeof(u32),1,fp);
		fwrite(&RoomHeader.lForeground,sizeof(u32),1,fp); 
		fwrite(&RoomHeader.lLevelData,sizeof(u32),1,fp);
		fwrite(&RoomHeader.lBackLayer,sizeof(u32),1,fp);
		fwrite(&RoomHeader.lClipData,sizeof(u32),1,fp); 
		fwrite(&RoomHeader.lBackgroundTSA,sizeof(u32),1,fp);
		fwrite(&RoomHeader.bUnknown1,sizeof(u8),1,fp);
		fwrite(&RoomHeader.TransForeground,sizeof(u8),1,fp);
		fwrite(&RoomHeader.iSep1,sizeof(u16),1,fp);
		fwrite(&RoomHeader.lSpritePointer,sizeof(u32),1,fp); 
		fwrite(&RoomHeader.bSpriteIndex1,sizeof(u8),1,fp);
		fwrite(&RoomHeader.bEventSwitch,sizeof(u8),1,fp);
		fwrite(&RoomHeader.iSep2,sizeof(u16),1,fp);
		fwrite(&RoomHeader.lSpritePointer2,sizeof(u32),1,fp); 
		fwrite(&RoomHeader.bSpriteIndex2,sizeof(u8),1,fp);
		fwrite(&RoomHeader.bEventSwitch2,sizeof(u8),1,fp);
		fwrite(&RoomHeader.iSeperator,sizeof(u16),1,fp);
		fwrite(&RoomHeader.lSpritePointer3,sizeof(u32),1,fp); 
		fwrite(&RoomHeader.bSpriteIndex3,sizeof(u8),1,fp);
		fwrite(&RoomHeader.bMiniMapRoomX,sizeof(u8),1,fp);
		fwrite(&RoomHeader.bMiniMapRoomY,sizeof(u8),1,fp);
		fwrite(&RoomHeader.bEffect,sizeof(u8),1,fp);
		fwrite(&RoomHeader.bSceneryYPos,sizeof(u8),1,fp);
		fwrite(&RoomHeader.bNothing,sizeof(u8),1,fp);
		fwrite(&RoomHeader.bMusic,sizeof(u8),1,fp);
		fwrite(&RoomHeader.blank,sizeof(u8),1,fp);
		
		SaveScroll();
     	SaveDoors();
	    LoadHeader(HeaderOffset);
	    
		
	}
	//fp = NULL;
	return 0;
}

int LoadZMROM(){
	
	GetArrays();
	for( int i = 0;i < 4;i++) 	 
	{
		SetUpCombos(i);
	}
	PopulateSpriteArray();
	return 0;
}


int LoadMFROM(){
	GetMFArrays();
	for( int i = 0;i < 4;i++) 	 
	{
		SetUpCombos(i);
				}
	PopulateSpriteArray();		
	return 0;
}

int LoadData(){

    if(RoomHeader.bBg0) GetLayerData(RoomHeader.bBg0, 0, RoomHeader.lForeground-0x8000000);
	if(RoomHeader.bBg1) GetLayerData(RoomHeader.bBg1, 1, RoomHeader.lLevelData-0x8000000);
	if(RoomHeader.bBg2) GetLayerData(RoomHeader.bBg2, 2, RoomHeader.lBackLayer-0x8000000);
	
	if(RoomHeader.lBg3==0x40){
		
		 GetLayerData(RoomHeader.lBg3, 3, RoomHeader.lBackgroundTSA-0x8000000);
	}else if((RoomHeader.lBg3&0xF0)==0xF0){
        GetCBG();
		}
	 GetLayerData(0x10, 4, RoomHeader.lClipData-0x8000000);
	return 0;
}


int GetCBG(){
    u32 palpos=0;
	u8 buffer[32192]={0};
	u32 size=0;
	int i =0;
	long pal[256]={0};
	u32 points[3]={0};
	int decmpsize=0;
    fseek(GBA.ROM,RoomHeader.lBackgroundTSA-0x8000000,SEEK_SET);
	fread(&ThisBackground.size,1,1,GBA.ROM);
	if(ThisBackground.size ==0){
		ThisBackground.X = 32; 
		ThisBackground.Y = 32;
	}else if((ThisBackground.size == 1)||(ThisBackground.size >= 3)) {
		ThisBackground.X = 64;
		ThisBackground.Y = 32;
	}else if(ThisBackground.size == 2){
		ThisBackground.X = 32;
		ThisBackground.Y = 64;
	}
    fread(&palpos,1, 1,GBA.ROM);
	fseek(GBA.ROM,RoomHeader.lBackgroundTSA-0x8000000+4,SEEK_SET);
	fread(points,1,12,GBA.ROM);
    
    fseek(GBA.ROM, points[0]-0x8000000,SEEK_SET);
	fread(buffer,1,32192,GBA.ROM);
	size=GBA.LZ77UnComp(buffer,(u8*)(GBA.GBAPal));

  
 
	GBA.DecodePal(GBA.GBAPal,pal,((size/2)+15) / 16, 0);//for test size is 1
	for(i=0;i<size/2;i++){
		PcPalMem[palpos*16 + i]=pal[i];
	}

	memset(&GBA.CompBuffer,0,64691);

	fseek(GBA.ROM,points[1]-0x8000000,SEEK_SET);
	fread(GBA.CompBuffer,1,64691,GBA.ROM);


	decmpsize = GBA.LZ77UnComp(GBA.CompBuffer,buffer);
	ThisBackground.oSize = decmpsize;

	memset(ThisBackground.TileBuf2D,0,0x20000);
	memcpy(ThisBackground.TileBuf2D,buffer,ThisBackground.oSize);
	
    fseek(GBA.ROM,points[2]-0x8000000,SEEK_SET);
	//Seek the compressed Tileset
	fread(&GBA.CompBuffer,sizeof(char),32691,GBA.ROM);//Read compression
    size = GBA.LZ77UnComp(GBA.CompBuffer, buffer);
	memcpy(&BGBuf[0x7DE0-size],buffer,size);


   BGImage.Load(BGBuf,1024);
   //BGImage.
	return 0;
}
int DrawBackGround(Image* img){
	//We gotta do something about repeating
	
	int difference;
	int mX=ThisBackground.X;
	int mY=ThisBackground.Y;
	difference = (mY>mX? mX:mY);
	int HorScenRep = 0;
	int VerScenRep = 0;
	nHScroll[SceneHScroll]=nVScroll[SceneVScroll]=nVScroll[STVScroll]=0;
	nMaxHScroll[SceneHScroll]=0;
	nMaxVScroll[SceneVScroll]=mY/8;
	nMaxVScroll[STVScroll]=2;//for now
	img->SetPalette(PcPalMem);
	int i , x, y, scrX, scrY;
	i=x=y=scrX=scrY=0;//
	int rex = (mX == 64 ? 2 :  1);
	int rey = (mY == 64 ? 2 :  1);
	
	
	if(mX && mY){
				for(scrY = 0; scrY < rey; scrY++)
				{	
					for(scrX = 0; scrX < rex; scrX++)
					{
						for(y = 0; y < 32; ++y)
						{
							for(x = 0; x < 32; ++x)
							{
                                for(int WRep = 0; WRep<= ThisLevelData.X/mX + 1 ;WRep++){
									for(int HRep = 0;HRep<=ThisLevelData.Y/mY + 1;HRep++){
										img->Draw(BGImage,x*8 + scrX*256 + (WRep*(mX*8)) ,y*8+ scrY*256+ (HRep*(mY*8)) ,  ThisBackground.TileBuf2D[i]);
									}
								}
								i++;
							}
						}
					}
				}
				}

				return 0; 
}




int DrawRoom2(){
	u8 cSize=0;
	u8 fd=0;
	int Width=img[1].Width,Height=img[1].Height;
	int k =0;
    int i = 0;
	
	if(!((crf == 0)||(crf==1))) return 0;
	
	
	Image ImgBuf;
	img[iRoom].Create(ThisLevelData.X*16,ThisLevelData.Y*16);
	
	ThisBackBuffer.Create(ThisLevelData.X*16,ThisLevelData.Y*16);
	SetBkMode(ThisBackBuffer.DC(), TRANSPARENT);
	SetTextColor(ThisBackBuffer.DC(),RGB(255,255,255));
	img[iRoom].SetPalette(PcPalMem);
	
 	
	TileImage.Load(fGbuf,1024);
	ImgBuf.Create(ThisLevelData.X*16,ThisLevelData.Y*16);
	ImgBuf.SetPalette(PcPalMem);
	
	  if(RoomHeader.lBg3&&0x40 || RoomHeader.lBg3&& 0xF0 )	DrawBackGround(&ImgBuf); 
	  for(i=0;i<3;i++){//Draw in order of importance


	  }
	return 0;
}

int DrawRoom(){

	u8 cSize=0;
	u8 fd=0;
	u32 fWidth=0,fHeight=0;
	//int Width=img[1].Width,Height=img[1].Height;
	int k =0;

	u16 Width=ThisLevelData.X*16, Height=ThisLevelData.Y*16;
	if(!((crf == 0)||(crf==1))) return 0;
	
	
//	Image ImgBuf;
	img[iRoom].Create(ThisLevelData.X<<4,ThisLevelData.Y<<4);
	
	ThisBackBuffer.Create(Width, Height);
//	BB.Create(Width, Height);
	SetBkMode(ThisBackBuffer.DC(), TRANSPARENT);
	SetTextColor(ThisBackBuffer.DC(),RGB(255,255,255));
	img[iRoom].SetPalette(PcPalMem);
	
 	
	TileImage.Load(fGbuf,1024);
//	ImgBuf.Create(ThisLevelData.X<<4,ThisLevelData.Y<<4);
//	ImgBuf.SetPalette(PcPalMem);
	
	  if(RoomHeader.lBg3&&0x40 || RoomHeader.lBg3&& 0xF0 )	DrawBackGround(&ThisBackground.BImage); 
	
     ThisBackground.BImage.Blit(ThisBackBuffer.DC(),0,0,ThisLevelData.X <<4 ,ThisLevelData.Y <<4,0,0);
 
	if(CheckBoxes[ViewB].value()==BST_CHECKED){
		if(ThisBackLayer.Dirty){
			DrawLayer(&ThisBackLayer, RoomHeader.bBg2);//Backlayer
		    ThisBackLayer.Dirty=0;
		} 
		if(RoomHeader.lBg3==0x40){
			ThisBackLayer.BImage.TransBlit(ThisBackBuffer.DC(),0,0,Width, Height,0,0);
		}else{
            ThisBackLayer.BImage.Blit(ThisBackBuffer.DC(),0,0,Width, Height,0,0);
		}
	
	}
	
	if(CheckBoxes[ViewL].value()){
		if(ThisLevelData.Dirty){	
			DrawLayer(&ThisLevelData, RoomHeader.bBg1);//Level
			ThisLevelData.Dirty=0;
			
		}
	ThisLevelData.BImage.TransBlit(ThisBackBuffer.DC(),0,0,Width, Height,0,0);
	}
	
				
				
	

	if(CheckBoxes[ViewF].value()){
		if(ThisForeground.Dirty){
		  DrawLayer(&ThisForeground, RoomHeader.bBg0);//Foreground
		  ThisForeground.Dirty=0;
	   	}
		if(RoomHeader.bBg0==0x40){
			fWidth=ThisLevelData.X;
			fHeight=ThisLevelData.Y;
		}else{
            fWidth=ThisForeground.X;
			fHeight=ThisForeground.Y;

		}
		fWidth<<=4;
		fHeight<<=4;
        if(chkDoTrans.value() == 1)
		 ThisForeground.BImage.AlphaBlit(ThisBackBuffer.DC(),0,0,Width, Height,0,0,255);
	    else
		 ThisForeground.BImage.TransBlit(ThisBackBuffer.DC(),0,0,Width, Height,0,0);
	    
	}
	
	  
	
	
	
	
	img[iRoom].TransBlit(ThisBackBuffer.DC(),0,0,Width, Height,0,0);
	ShowSprites((u8)Combos[cSpriteSet].GetListIndex());
	DisplayDoors();
	if(ViewClip.value()   ==1)DrawClipIdent();
	if(ScrollCheck.value()==1)DrawScrolls  (cboScroll.GetListIndex());
	
	InvalidateRect(hwndMap,0,1);
     
	//SendMessage(hwndMap,WM_SIZE,1,0);

	return 0;
}


int DrawLayer(nRoomBuff* Map, u8 ctype){//img is the image to blit to 
int thisX=0,thisY=0,mX=0,mY=0;
u16 TILE = 0;
int i =0;

Map->BImage.Clear();
if(ctype==0) Map->BImage.Create(0,0);//Take up very little memory
if(ctype == 0x40){//LZ 
    Map->BImage.Create(ThisLevelData.X*16,ThisLevelData.Y*16);
	Map->BImage.SetPalette(PcPalMem);
		//this type uses the background set for tiles.
		
		for(int ScenRep = 0;ScenRep<ThisLevelData.X;ScenRep++){
			for(thisX=0;thisX<Map->X;thisX++){
				for(thisY=0;thisY<Map->Y;thisY++){
					Map->BImage.Draw(BGImage, (ScenRep*32)+(thisX)* 8,(RoomHeader.bSceneryYPos-1)*16 + (thisY) * 8, Map->TileBuf2D[(thisX)+(thisY*Map->X )]);
				}
			}
		}
	
}else if(ctype == 0x10){

	for(thisY = 0; thisY<Map->Y;thisY++){
		for(thisX = 0; thisX < Map->X;thisX++){// from here if something is enabled then draw it 
			//BG layer
		
				
				//RLE
					
					//TILE =(Map->TileBuf2D[thisX+(thisY * (Map->X))])<<2;
					/*
					Map->BImage.Draw(TileImage,thisX* 16, (thisY) * 16, TSA.nTSA[TILE++]);
					Map->BImage.Draw(TileImage,(thisX * 16) + 8, (thisY) * 16, TSA.nTSA[TILE++]);
					Map->BImage.Draw(TileImage,(thisX * 16), ((thisY) * 16)+8, TSA.nTSA[TILE++]);
					Map->BImage.Draw(TileImage,(thisX * 16)+8, ((thisY) * 16)+8, TSA.nTSA[TILE]);
					*/
			        TILE =(Map->TileBuf2D[thisX+(thisY * (Map->X))]);
					BitBlt(Map->BImage.DC(),(thisX)* 16, (thisY)* 16,16,16,img[iTileset].DC(),(TILE%16)*16,(TILE/16)*16,SRCCOPY);
					//	img[iTileset].Blit(hdc, 0,0,coord.right - coord.left ,coord.bottom-coord.top,0,nVScroll[sTileset]*16);
			
   
			}
		}
	}



	return 0;
}


