#include "MainHeader.h"


int GetTileset(u8 Tileset){
	unsigned char decompbuf[84100]={0};
	long decomplength=0;
    //long Tileset=0;
	u16  TileCheck=0;
    int  i =0;
   memset(&fGbuf,0,sizeof(fGbuf));
   memset(&BGBuf,0,sizeof(BGBuf));
   memset(&PcPalMem,0,sizeof( PcPalMem));
    //Tileset = Combos[1].GetListIndex();
	if(crf == 0){
	fseek(GBA.ROM,RoomTilesets[Tileset].gTiles-0x8000000,SEEK_SET);//Seek the compressed Tileset
	fread(&GBA.CompBuffer,sizeof(char),64691,GBA.ROM);//Read compression
	fseek(GBA.ROM,RoomTilesets[Tileset].pTiles-0x8000000,SEEK_SET);//Seek the endcoded pal
	fread(&GBA.GBAPal[32],sizeof(short),0x1E0,GBA.ROM);//Read pal
	fseek(GBA.ROM,RoomTilesets[Tileset].TSAMap-0x8000000,SEEK_SET);
    }else if(crf == 1){
    fseek(GBA.ROM,MFRoomTilesets[Tileset].gTiles-0x8000000,SEEK_SET);//Seek the compressed Tileset
	fread(&GBA.CompBuffer,sizeof(char),64691,GBA.ROM);//Read compression
	
	fseek(GBA.ROM,MFRoomTilesets[Tileset].pTiles-0x8000000,SEEK_SET);//Seek the endcoded pal
	fread(&GBA.GBAPal[32],sizeof(short),0x1E0,GBA.ROM);//Read pal c
	fseek(GBA.ROM,MFRoomTilesets[Tileset].TSAMap-0x8000000,SEEK_SET);
	}
	 
	
	memset(&TSA.nTSA,0,sizeof(TSA.nTSA));
	fread(&TSA.ID,sizeof(short),1,GBA.ROM); 
	TSA.max=0;
	//fread(&TSA.nTSA,sizeof(short),0x1080,GBA.ROM);
    for(i = 0;i<0x1080;i++){
          fread(&TileCheck,2,1,GBA.ROM); 
		  	TSA.nTSA[i]=TileCheck;
		  if(TileCheck==0x2){
		break;
		
		  }
		  	TSA.max++;
	}
    TSA.max/=4;

	GBA.GBAPal[0]=0;
	GBA.GBAPal[16] = 0;
	
	
	if(crf == 0){
	fseek(GBA.ROM,0x31C72E,SEEK_SET);
	fread(&GBA.GBAPal[1],sizeof(short),15,GBA.ROM);
    fseek(GBA.ROM,0x3ED51C,SEEK_SET);
	fread(&GBA.GBAPal[16],sizeof(short),16,GBA.ROM);
	}
	if(crf ==0){
		if( (u8)Combos[cArea].GetListIndex() == 6){
			fseek(GBA.ROM,0x5DA40C,SEEK_SET);
			fread(&fGbuf[2048],1,4098,GBA.ROM);   
		}else{
            fseek(GBA.ROM,0x5D940C,SEEK_SET);
			fread(&fGbuf[0x800],1,4098,GBA.ROM);
		}
	}else if(crf == 1){
        GBA.GBAPal[0] = 0;
		fseek(GBA.ROM,0x40805E,SEEK_SET);
		fread(&GBA.GBAPal[1],2,47,GBA.ROM);
		fseek(GBA.ROM,0x3F28C8,SEEK_SET);	
		fread(&fGbuf[0x800],1,4098,GBA.ROM);
	}
    GBA.DecodePal(GBA.GBAPal, PcPalMem, 16, 0);
	 InvalidateRect(hwndLPE,0,1);
 

	   
    
	 
	long size =GBA.LZ77UnComp(GBA.CompBuffer, decompbuf);
		 
	//memcpy(fGbuf[6144],decompbuf[0],size);
   for( i = 0;i<size;i++)fGbuf[6144+i]=decompbuf[i];
   if(!crf)  LoadSpecialEffects(RoomTilesets[Tileset].EffectSet);
   if(crf) LoadSpecialEffects(MFRoomTilesets[Tileset].EffectSet);
  

	TileImage.Load(fGbuf,1024);

    DrawTileset();

	if(RoomHeader.lBg3==0x40){
if(!crf) fseek(GBA.ROM,RoomTilesets[Tileset].gBackground-0x8000000,SEEK_SET);
if(crf)  fseek(GBA.ROM,MFRoomTilesets[Tileset].gBackground-0x8000000,SEEK_SET);//Seek the compressed Tileset
	fread(&GBA.CompBuffer,sizeof(char),32691,GBA.ROM);//Read compression
   size = GBA.LZ77UnComp(GBA.CompBuffer, decompbuf);
	memcpy(&BGBuf[0x7DE0-size],&decompbuf[0],size);
}
  for(int ii = 0; ii<512;ii++)  BGBuf[0x7DE0+ii]=fGbuf[0x600+ii];
	
   BGImage.Load(BGBuf,1024);



	return 0;

}
int DrawBlock(short Map16n , int destX , int destY){
 
	    img[0].Draw(TileImage,(destX), (destY), (short)TSA.nTSA[Map16n]);
		img[0].Draw(TileImage,(destX) + 8, (destY), (short)TSA.nTSA[(Map16n)+1]);
		img[0].Draw(TileImage,(destX), (destY) + 8, (short)TSA.nTSA[Map16n+2]);
		img[0].Draw(TileImage,(destX) + 8, (destY) + 8, (short)TSA.nTSA[Map16n+3]);
	
		return 0;
}
void DrawTileset(){
    int k=0;
    int i=0;
	int TC=0;
	int end=768;
	
 
  
	img[0].Clear();
	img[0].SetPalette(PcPalMem);
//	BBTileset.Create(512,512);
    
	for( i= 0; i<TSA.max;i++)
	{
      
		     DrawBlock( i*4, (i % 16) * 16, ((i / 16)) * 16);


    }
//    img[0].Blit(BBTileset.DC(),0,0,512,512,0,0);
	nVScroll[sTileset] = 0;
    InvalidateRect(hwndTileset,0,1);

}
int LoadSpecialEffects(long EffectNum){

long  reference_table,tileset_table,ref_offset=0;
long  ani_source,gfx_destination,i,pointer=0;
 

u8 ref_array[0x30];
u8 Graphic[128];
 
 
/* Don't need these if statements for now.*/
/*if(file = "ZM" Then
 reference_table = &H35FA78
 tileset_table = &H35F948
 if (header = "PBMXP01") Then
    reference_table = &H360704
    tileset_table = &H3605D
 End if
Else
 reference_table = &H3C8F90
 tileset_table = &H3C8D58
End if*/
if(crf == 0){
 reference_table = 0x35FA78;
 tileset_table = 0x35F948;
}else if(crf ==1){
 reference_table = 0x3C8F90;
 tileset_table =0x3C8D58;
}
 ///if(!PreLoad){

fseek(GBA.ROM,reference_table + ((EffectNum&0xFF) * 0x30),SEEK_SET);
fread(&ref_array,sizeof(u8),0x30,GBA.ROM);

 for(i = 0; i < 16;i++){

	//if(    ref_array[i * 3] == 0) continue; 
	//if not last animation, but no animation there, exit)
	ani_source = (tileset_table + (8 * ref_array[i * 3]));
    fseek(GBA.ROM,ani_source,SEEK_SET);
	fread(&SpecialEffects[i].Animated,sizeof(u8),1,GBA.ROM);
	fread(&SpecialEffects[i].Timer,sizeof(u8),1,GBA.ROM);
	fread(&SpecialEffects[i].GraphicEnd,sizeof(u16),1,GBA.ROM);
	fread(&SpecialEffects[i].GraphicPnt,sizeof(u32),1,GBA.ROM);
	gfx_destination = i *0x80; //if 0 is bufferstart...
	if(SpecialEffects[i].GraphicPnt<0x7FFFFFF) continue;
	fseek(GBA.ROM,SpecialEffects[i].GraphicPnt - 0x8000000,SEEK_SET);

	fread(&Graphic[0],sizeof(u8),128,GBA.ROM);
	for (int ii = 0; ii < 128;ii++)	fGbuf[gfx_destination + ii] = Graphic[ii];
 
 }
//Copy from Tilemem to BGMem

return 0;
}

int ZMGlobalGFX(u8 Area){
/*
Dim g2Buf(0 To 4096) As Byte
Dim thispal(0 To 15) As Integer
Dim fakepal(1 To 15) As Integer
Dim thatpal(0 To 0, 0 To 15) As Long*/


if( Area == 6){
   
   fseek(GBA.ROM,0x5DA40C,SEEK_SET);
   fread(&fGbuf[2048],1,4098,GBA.ROM);
    //If (header = "PBMXP01") Then Get GBA.ROM, &H5ED460 + 1, g2Buf
   
}else{
  
   fseek(GBA.ROM,0x5D940C,SEEK_SET);
   fread(&fGbuf[0x800],1,4098,GBA.ROM);
//    If (header = "PBMXP01") Then Get GBA.ROM, &H5EC460 + 1, g2Buf
}
	
//Get FileNo, &H3ED51C, thispal
//Get FileNo, &H31C72E, fakepal
//If (header = "PBMXP01") Then Get FileNo, &H3EE1A9, thispal
//If (header = "PBMXP01") Then Get FileNo, &H31D3BB, fakepal
//'CopyMemory GbaPalMem(1), fakepal(1), 15
/*
For i = 1 To 15
GbaPalMem(i) = fakepal(i)
GbaPalMem(i + 16) = thispal(i)
Next i*/



//CopyMemory fGbuf(2048), g2Buf(0), 4096

return 0;
}


int MFGlobalGFX(){




GBA.GBAPal[0] = 0;
fseek(GBA.ROM,0x40805E,SEEK_SET);
fread(&GBA.GBAPal[1],2,47,GBA.ROM);

fseek(GBA.ROM,0x3F28C8,SEEK_SET);
fread(&fGbuf[0x800],1,4098,GBA.ROM);

return 0;

}




