#include "MainHeader.h"

sCombo::~sCombo()
{
   Clear();
}
sCombo::sCombo()
{
   cClear();
}

int             sCombo::Init(HWND sComboHwnd)
{
   hCombo = sComboHwnd;
   Clear();
   return 0;
}
int             sCombo::Disable()
{
   EnableWindow(hCombo, 0);
   return 0;
}
int             sCombo::Enable()
{
   EnableWindow(hCombo, 1);
   return 0;
}
int             sCombo::cClear()
{
   hCombo = NULL;
   return 0;
}
int             sCombo::Clear()
{
   SendMessage(hCombo, CB_RESETCONTENT, 0, 0);
   return 0;
}
long            sCombo::GetListIndex()
{
   return SendMessage(hCombo, CB_GETCURSEL, 0, 0);
}

int             sCombo::SetListIndex(int Value)
{
   SendMessage(hCombo, CB_SETCURSEL, Value, 0);
   return 0;
}
int             sCombo::sList(int index)
{
   SendMessage(hCombo, CB_GETITEMDATA, index, 0);
   return 0;
}
int             sCombo::Click()
{
   return 0;
}

int             sCombo::Additem(char *string)
{
   SendMessage(hCombo, CB_ADDSTRING, 0, (long) string);
   return 0;
}

HWND            sCombo::thishwnd()
{
   return hCombo;
}

Scroller::Scroller()
{
   ;
}

Scroller::~Scroller()
{
   ;
}
sChecks::~sChecks()
{
   cClear();
}
sChecks::sChecks()
{
   cClear();
}

int             sChecks::cClear()
{
   check = NULL;
   return 0;
}

int             sChecks::SetCnt(HWND hwnd)
{
   check = hwnd;
   return 0;
}

int             sChecks::value()
{

   return SendMessage(check, BM_GETCHECK, 0, 0);
}

int             sChecks::value(u8 Val)
{
   if (Val < 3)
   {
      SendMessage(check, BM_SETCHECK, Val, 0);
   } else
   {
      sMessage("Bad checkbox value");
   }
   return 0;
}

int             sChecks::State(bool flag)
{
   EnableWindow(check, flag);
   return 0;
}

int             sChecks::State()
{

   return IsWindowEnabled(check);
}

LRESULT CALLBACK ScrollProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
   int             i = 0;
   char            buf[100];
   HWND            wnd;

   switch (message)
   {

   case WM_LBUTTONDOWN:
      for (i = 0; i < scroll.Number + 2; i++)
      {
         wnd = hScroll[i];
         if (wnd == hWnd)
         {
            CurObjT = dScroll;
            CurObjNo = i;
            break;
         }
      }
      // lblObjT Object Type
      SetWindowText(GetDlgItem(Main, lblObjT), "Object Type: Scroll");
      sprintf(buf, "Object #:: %d", CurObjNo);
      SetWindowText(GetDlgItem(Main, lblObjNo), buf);

      break;
   case WM_MOUSEMOVE:

      break;
   case WM_PAINT:

      break;
   case WM_DESTROY:

      break;
   }

   return DefWindowProc(hWnd, message, wParam, lParam);

}

int             stxts::SetHwnd(HWND hwnd)
{
   thisHwnd = hwnd;
   return 0;
}
int             stxts::GetText()
{

   int             val = 0;
   char            buf[100];

   GetWindowText(thisHwnd, buf, 4);
   sscanf(buf, "%d", &val);
   return val;
}

int             stxts::SetText(char *string)
{
   SetWindowText(thisHwnd, string);
   return 0;
}

int             DrawTileRect(HDC hdc, MousePointer mpointer, int mul)
{
   RECT            myrect;
   HBRUSH          curbrush = CreateSolidBrush(RGB(255, 0, 0));

   myrect.left = mpointer.sX * mul;
   myrect.top = mpointer.sY * mul;
   myrect.right = mpointer.Width * mul + myrect.left;
   myrect.bottom = myrect.top + mpointer.Height * mul;
   FrameRect(hdc, &myrect, curbrush);
   DeleteObject(curbrush);
   return 0;
}

LRESULT CALLBACK InputBoxProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

   int             choice = -1;
   char            buf[200];

   switch (message)
   {

   case WM_SHOWWINDOW:
      SetWindowText(GetDlgItem(hWnd, lblEnter), procstring);
      break;

   case WM_COMMAND:
      if (LOWORD(wParam) == cmdInputOK)
      {
         GetWindowText(GetDlgItem(hWnd, txtInput), buf, 4);
         sscanf(buf, "%x", &choice);
         ShowWindow(hWnd, SW_HIDE);

         EndDialog(hWnd, choice);
      }
      break;

   }

   return DefWindowProc(hWnd, message, wParam, lParam);
}

int             LoadInput(long val)
{
   int             blah;

   blah = DialogBox(hGlobal, MAKEINTRESOURCE(frmInputBox), 0, (int (__stdcall *) (struct HWND__ *, unsigned int, unsigned int, long)) InputBoxProc);
   if (blah > -1)
      return blah;
   return val;
}

sList::~sList()
{
   Clear();
}
sList::sList()
{
   cClear();
}

int             sList::Init(HWND sListHwnd)
{
   hCombo = sListHwnd;
   Clear();
   return 0;
}
int             sList::Disable()
{
   EnableWindow(hCombo, 0);
   return 0;
}
int             sList::Enable()
{
   EnableWindow(hCombo, 1);
   return 0;
}
int             sList::cClear()
{
   hCombo = NULL;
   return 0;
}
int             sList::Clear()
{
   SendMessage(hCombo, LB_RESETCONTENT, 0, 0);
   return 0;
}
long            sList::GetListIndex()
{
   return SendMessage(hCombo, LB_GETCURSEL, 0, 0);
}

int             sList::SetListIndex(int Value)
{
   SendMessage(hCombo, LB_SETCURSEL, Value, 0);
   return 0;
}
int             sList::sListStrings(int index)
{
   SendMessage(hCombo, LB_GETITEMDATA, index, 0);
   return 0;
}

int             sList::Additem(char *string)
{
   SendMessage(hCombo, LB_ADDSTRING, 0, (long) string);
   return 0;
}

HWND            sList::thishwnd()
{
   return hCombo;
}
int             GimmeAdoor(int X, int Y)
{
   int             i = 0;
   int             door = 0;
   int             curX = 0;
   int             curY = 0;
   int             curH = 0;
   int             curW = 0;

   // Function returns what door the is touching
   for (i = 0; i < DoorBuf.DoorCount; i++)
   {

      if (Doors[DoorBuf.DoorNotes[i]].OwnerRoom == Combos[cRoom].GetListIndex())
      {
         curX = Doors[DoorBuf.DoorNotes[i]].XEntrance;
         curY = Doors[DoorBuf.DoorNotes[i]].YEntrance;
         curH = (Doors[DoorBuf.DoorNotes[i]].DHeight); // -Doors[DoorBuf.DoorNotes[i]].YEntrance)+1;

         curW = (Doors[DoorBuf.DoorNotes[i]].DWidth); // -Doors[DoorBuf.DoorNotes[i]].XEntrance)+1;
         // ShowWindow((HWND)hDoors[i],SW_SHOW);
         // MoveWindow((HWND)hDoors[i],(u16)(curX-minX)*16,(u16)(curY-minY)*16,(curW+1)*16,(curH-curY+1)*16,0);

         if ((curX <= X) &&
             (curW >= X) &&
             (curY <= Y) &&
             (curH >= Y))
         {

            return i;
         }
      }
   }
   return -1;
}

int             Findmeascroll(int X, int Y)
{
   int             scrollnum = 0;
   int             MainX = 0;
   int             MainY = 0;
   int             MainH = 0;
   int             MainW = 0;
   int             curX = 0;
   int             curY = 0;
   int             curH = 0;
   int             curW = 0;
   int             i = 0;
   int             j = 0;
sctype thisScroll=scroll.Scrolls[cboScroll.GetListIndex()];
/*
 * Given an X,Y
 * This function will find what rectangle you are in, then will go deeper and find 
 * if said rectangle is intersecting this will take some time to code -.-
 */
  
if ((scroll.Room != 0xFF) && (thisScroll.xStart != 0xFF) && (thisScroll.yEnd != 0xFF)){
         
            MainX = thisScroll.xStart;
            MainY = thisScroll.yStart;
            MainW = thisScroll.xEnd;
            MainH = thisScroll.yEnd;
            if (((MainX) <= X) && ((MainW) >= X) &&
                ((MainY) <= Y) && ((MainH) >= Y))
            {
               
               return cboScroll.GetListIndex();
            }
         
      
   }
   return -1; // Nothing was found

}

int             Gimmeasprite(int X, int Y, int giveback)
{
   int             i = 0;
   int             x = 0;
   int             y = 0;
   int             width = 0;
   int             height = 0;

   switch ((u8) Combos[cSpriteSet].GetListIndex())
   {
   case 0:
      for (i = 0; i < Enemy1.max; i++)
      {

         width = OverallSize[(Enemy1.Enemies[i].Creature & 0xF) - 1].right - OverallSize[(Enemy1.Enemies[i].Creature & 0xF) - 1].left;

         height = OverallSize[(Enemy1.Enemies[i].Creature & 0xF) - 1].bottom - OverallSize[(Enemy1.Enemies[i].Creature & 0xF) - 1].top;
         x = Enemy1.Enemies[i].X;
         y = Enemy1.Enemies[i].Y;
         if (((x) <= X) &&
             ((x + width / 16) >= X) &&
             ((y) <= Y) &&
             ((y + height / 16) >= Y))
         {

            if (giveback)
            {
               MovingSprite[0] = 1;
               MovingSprite[1] = i;
            }
            return i;
         }
      }
      break;
   }

   return -1;
}

int             DrawClipIdent()
{
   int             currclip = Combos[cClip].GetListIndex();
   RECT            blah;
   int             thisX = 0;
   int             thisY = 0;
   int             x = 0;
   int             y = 0;

   HBRUSH          curbrush = CreateSolidBrush(RGB(255, 255, 255));

   for (thisY = 0; thisY < ThisLevelData.Y; thisY++)
   {
      for (thisX = 0; thisX < ThisLevelData.X; thisX++)
      {

         if (ThisClipData.TileBuf2D[thisX + (thisY * (ThisClipData.X))] == currclip)
         {

            blah.left = thisX * 16;
            blah.right = thisX * 16 + 16;
            blah.top = thisY * 16;
            blah.bottom = thisY * 16 + 16;

            FrameRect(ThisBackBuffer.DC(), &blah, curbrush);

         }
      }
   }
   DeleteObject(curbrush);
   InvalidateRect(hwndMap, 0, 1);
   return 0;
}

int             HandleMapLeftButton(UINT message, WPARAM wParam, LPARAM lParam)
{
   if (wParam == MK_LBUTTON){

      // Hey there let's check our dimensions.
	   if (ScrollCheck.value() == 1){
         if (!MovingScroll[0]){
            MovingScroll[1] = Findmeascroll(((GetX(lParam) / 16) + nHScroll[sHMap]), ((GetY(lParam) / 16) + nVScroll[sVMap]));

            if (MovingScroll[1]){
               MovingScroll[0] = 1;

            }else{
               MovingScroll[0] = MovingScroll[1] = 0;
			}
         }
         return 0;
      } else 
		 if (ScrollCheck.value() == 0){
			 if (MovingSprite[0] == 0 && CheckBoxes[chkES].value() == 1){
            if (Gimmeasprite(((GetX(lParam) / 16) + nHScroll[sHMap]), ((GetY(lParam) / 16) + nVScroll[sVMap]), 1) != -1)
            {
               return 0;
            }
         }
         if (MovingDoor[0] == 0 && CheckBoxes[chkED].value() == 1)
         {
            MovingDoor[1] = GimmeAdoor(((GetX(lParam) / 16) + nHScroll[sHMap]), ((GetY(lParam) / 16) + nVScroll[sVMap]));
            if (MovingDoor[1] != -1)
            {
               MovingDoor[0] = 1;
               return 0;
            }
         }
		 		if(wParam == (MK_LBUTTON| MK_CONTROL)){
				ClipBoard.CopyTiles(lParam);
				DrawRoom();
				//InvalidateRect(hwndMap,0,1);
				return 0;
			}
		
         if (CheckBoxes[Foreground].value() == 1 || chkMC[0].value() == 1){
            EditThisLayer(&ThisForeground, lParam, 1, Tile);
            ThisForeground.Dirty = 1;
            ThisForeground.SDirty = 1;

         }
         else 
		 if (CheckBoxes[Level].value() == 1 || chkMC[1].value() == 1){
            EditThisLayer(&ThisLevelData,lParam, 1, Tile);
            ThisLevelData.Dirty = 1;
            ThisLevelData.SDirty = 1;
         }
		 else 
         if (CheckBoxes[Background].value() == 1 || chkMC[2].value() == 1){
            EditThisLayer(&ThisBackLayer, lParam, 1, Tile);
            ThisBackLayer.Dirty = 1;
            ThisBackLayer.SDirty = 1;
         }
		 else 
         if (CheckBoxes[Clip].value() == 1 || chkMC[3].value() == 1){
            EditThisLayer(&ThisClipData,lParam, 0, Combos[cClip].GetListIndex());
            ThisClipData.Dirty = 1;
            ThisClipData.SDirty = 1;
         }
      }
      DrawRoom();
      InvalidateRect(hwndMap, 0, 1);
   }
   return 0;
}
/*
int             EditThisLayer(nRoomBuff * Layer, LPARAM lParam, byte usens, u16 ToUse, int mul)
{ // Layer to use, XY value, if it's bigger then 16x16

   int             baseX = (GetX(lParam) / mul);

   baseX += (mul == 16 ? nHScroll[sHMap] : 0);
   int             baseY = (GetY(lParam) / mul);

   baseY += (mul == 16 ? nVScroll[sVMap] : 0);
   int             y = 0;
   int             x = 0;
   int             ny = 0;
   int             nx = 0;
   int             add = 0;
   int             width = Layer->X;
   MousePointer    cMP =  (MPToUse ? mpTileset:mpMap);
   if (mul == 8)
   { // Editing scenery
      // ns == switch between tileset and map copy?

      if (SCS == 0)
      { // Tilecopy

         for (y = 0; y < mpSTS.Height; y++)
         {
            for (x = 0; x < mpSTS.Width; x++)
            {
               add = 0;
               // Make sure it's in bounds
               if ((baseX + x) >= 31 && !(add & 0x3E0))
                  add += 0x3E0;
               // if(baseY>31) add+=1024;
               Layer->TileBuf2D[(baseX + x) + (baseY + y) * (width / 2) + add] = ToUse + (x) + (y) * (width / 2);

            }
         }
      } else if (SCS == 1)
      { // Map Copy

         for (y = 0; y < mpSTS.Height; y++)
         {
            for (x = 0; x < mpSTS.Width; x++)
            {
               add = 0;
               // Make sure it's in bounds
               if (baseX >= 31 || x >= 31 && !(add & 0x3E0))
                  add += 992;
               // if(baseY>31) add+=1024;
               Layer->TileBuf2D[(baseX + x) + (baseY + y) * (width / 2) + add] = Layer->TileBuf2D[ToUse + (x) + (y) * (width / 2)];

            }
         }
      }
      return 0;
   }
      for (y = 0; y < cMP.Height; y++)
      {
         for (x = 0; x < cMP.Width; x++)
         {
      
			 if (!MPToUse && CheckBoxes[Clip].value() == 0) { // Map

				 if ( (cMP.Width >= 0 && cMP.Height >= 0)){
                   Layer->TileBuf2D[(baseX + x) + (baseY + y) * (width)] = Layer->TileBuf2D[Tile + (x) + (y) * (width)];
				 }
			 }else{
		
				 Layer->TileBuf2D[(baseX + x) + (baseY + y) * (width)] = ToUse + x + (y * 16);
				
			 }
			  
	  
		 }
	  }
	  Layer->SDirty = Layer->Dirty =1;
   DrawRoom();
   return 0;
}
*/
void             EditThisLayer(nRoomBuff * Layer, LPARAM lParam, byte usens, u16 ToUse, int mul){
 EditThisLayer(Layer, 0, lParam,  usens, ToUse,  mul);
}

int             EditThisLayer(nRoomBuff * Layer, WPARAM wParam, LPARAM lParam, byte usens, u16 ToUse, int mul)
{ // Layer to use, XY value, if it's bigger then 16x16

   int             baseX = (GetX(lParam) / 16)+ nHScroll[sHMap];;


   int             baseY = (GetY(lParam) / 16)+ nVScroll[sVMap];

 
   int             y = 0;
   int             x = 0;
   int             ny = 0;
   int             nx = 0;
   int             add = 0;
   int             mwidth = Layer->X;
   MousePointer    cMP = (MPToUse || (wParam & MK_SHIFT)) ? mpTileset : mpMap;
   	int width=0,height=0;

      if (!MPToUse && CheckBoxes[Clip].value() == 0 && (wParam == MK_CONTROL )){  
	              for (y = 0; y <  mpMap.Height; y++)
				  {
					 for (x = 0; x <  mpMap.Width; x++)
					 {
           
					  Layer->TileBuf2D[(baseX -( nHScroll[sHMap] ? 1:0)+ x) + (baseY-( nVScroll[sVMap] ? 1:0)  + y) * (mwidth)] = Layer->TileBuf2D[Tile + (x) + (y * mwidth)];


					 }
				  }
 
            
			 }else{  
     
	//Do some math to see how much we're looping
	
		if(mpMap.Width > mpTileset.Width){
			//Determine the difference
			width=mpMap.Width -mpTileset.Width;	
		}
		if(mpMap.Height> mpTileset.Height){

		   height=mpMap.Height- mpTileset.Height;
		}
				for(ny=0;ny<height+1;ny++){	
	                  for(nx=0;nx<width+1;nx++){
						
						  for (y = 0; y <  mpTileset.Height; y++)
						  {
					 
							if(ny*mpTileset.Height+y>mpMap.Height-1) break; 
							for (x = 0; x <  mpTileset.Width; x++)
							 { 
								   if(nx*mpTileset.Width + x  > mpMap.Width- 1) break;

           
								   if(Layer==&ThisClipData){	 
									Layer->TileBuf2D[(baseX + x ) + ( baseY + y) * (mwidth) + nx*mpTileset.Width + ny*mpTileset.Height *mwidth] = ToUse;
                                    
								   }else{
								     Layer->TileBuf2D[(baseX + x ) + ( baseY + y) * (mwidth) + nx*mpTileset.Width + ny*mpTileset.Height *mwidth] = ToUse + x + (y * 16);
                                     //Layer->TileBuf2D[(baseX-( nHScroll[sHMap] ? 1:0) + x) + (baseY-( nVScroll[sVMap] ? 1:0) + y) * (mwidth)] = ToUse + x + (y * 16);
								   }
							
								   }
						

						}
						 
					  }
				}
			 }
			 
   
		Layer->Dirty=Layer->SDirty=1; 
	//	DrawRoom();
      return 0;
   

 
}
nRoomBuff::nRoomBuff()
{

}
nRoomBuff::~nRoomBuff()
{

}
