#include "MainHeader.h"
int EnableConnections(){
	unsigned char blah[3];//Need three vars to test
	char max=0;
	long offset=0;
	int i = 0;
	if(crf == 0){
		fseek(GBA.ROM,0x05EEB8,SEEK_SET);
	}else if(crf == 1){
		fseek(GBA.ROM,0x6945c,SEEK_SET);
	}else{
		return 0;
	}
	fread(&offset,4,1,GBA.ROM);
	fseek(GBA.ROM,offset-0x8000000,SEEK_SET);

	while(1){
		fread(&blah,1,3,GBA.ROM);
		if((blah[0]==0xFF) && (blah[2]==0xFF)) {
			max = i - 3; 
			break;
		}
		i +=3;
	}
	max/=6;
	DoorConnections.Connects = max;
	fseek(GBA.ROM,offset - 0x8000000,SEEK_SET);
	for(i = 0;i<DoorConnections.Connects;i++){
		DoorConnections.DoorConnects[i].sA1= fgetc(GBA.ROM);
		DoorConnections.DoorConnects[i].D1= fgetc(GBA.ROM);
		DoorConnections.DoorConnects[i].dA1= fgetc(GBA.ROM);
		DoorConnections.DoorConnects[i].sA2= fgetc(GBA.ROM);
		DoorConnections.DoorConnects[i].D2= fgetc(GBA.ROM);
		DoorConnections.DoorConnects[i].dA2= fgetc(GBA.ROM);
	}
	
	
	return 0;
}


int DoesaBridgeExist(){//Will find any connection for this room only.
	u8 Area=0;
	u8 Door=0;
	u8 Room=0;
	char blah[5];
	int i=0;
	int ii = 0;
	Area= (u8)Combos[cArea].GetListIndex();
	Room =(u8) Combos[cRoom].GetListIndex();
	ConnectExists=0;
	for(i=0;i<0x100;i++) PSCE[i] =0;
	//How many doors are currently loaded
	for(i = 0;i<DoorConnections.Connects;i++){
		
		for(ii=0;ii<DoorBuf.DoorCount;ii++){
			//First we'll check the area then the oor
			if((Area == DoorConnections.DoorConnects[i].sA1)  || (Area == DoorConnections.DoorConnects[i].sA2) ){
				if((DoorConnections.DoorConnects[i].D1 == DoorBuf.DoorNotes[ii]) ||
				   (DoorConnections.DoorConnects[i].D2 == DoorBuf.DoorNotes[ii]) ){
					
					if((Doors[DoorConnections.DoorConnects[i].D1].OwnerRoom == Room)||
				       (Doors[DoorConnections.DoorConnects[i].D2].OwnerRoom == Room)){
						ConnectExists++;
						PSCE[ConnectExists] =i;
					}
				}
			}
		}
		
	} 
	if(ConnectExists==0) {
      	EnableWindow(GetDlgItem(DoorWin,cmdSaveConn),0);
		Combos[cA1].Disable();
	    Combos[cD1].Disable();
	    Combos[cA2].Disable();
     	Combos[cD2].Disable();
	    Combos[cConnect].Disable();
		return 0;
	}
	EnableWindow(GetDlgItem(DoorWin,cmdSaveConn),1);
	Combos[cA1].Enable();
	Combos[cD1].Enable();
	Combos[cA2].Enable();
    Combos[cD2].Enable();
	Combos[cConnect].Enable();
	Combos[cConnect].Clear();
	for(i = 0; i < ConnectExists;i++){
		sprintf(blah,"%X",i);
		Combos[cConnect].Additem(blah);
	}
	Combos[cConnect].SetListIndex(0);
	SendMessage(DoorWin,WM_COMMAND,HIWORD(CBN_SELCHANGE)|LOWORD(cboConnect),0);
	return 0;
}

int UserEnableConnections(){
	char strbuf[256];
	sprintf(strbuf,"Total Area Connects: %d",ConnectExists);
	SetWindowText(GetDlgItem(Main,lblC),strbuf);
	if(ConnectExists){
		EnableWindow(GetDlgItem(Main,cmdViewConnect),1);
	}else{
		EnableWindow(GetDlgItem(Main,cmdViewConnect),0);
	}
	return 0;
}

int SetConnections(u8 conn){
	conn = conn+1;
	Combos[cA1].SetListIndex(DoorConnections.DoorConnects[PSCE[conn]].sA1);
	Combos[cD1].SetListIndex(DoorConnections.DoorConnects[PSCE[conn]].D1);
	Combos[cA2].SetListIndex(DoorConnections.DoorConnects[PSCE[conn]].dA1);
	//Combos[cA2].SetListIndex(DoorConnections.DoorConnects[PSCE[conn]].sA2);
	Combos[cD2].SetListIndex(DoorConnections.DoorConnects[PSCE[conn]].D2);
	//Combos[cdA2].SetListIndex(DoorConnections.DoorConnects[PSCE[conn]].dA2);
	return 0;
}