#include "MainHeader.h"
int ExportRoom(){
	int i=0;
    char FileName[1024]={0};
	char FCHK[] ="DHFH";//FileHeader
	FILE* fp=NULL;
	GBA.ReturnFileName("Please name your room\0*.dhr\0",FileName,512,0);
    if(FileName)
		fp = fopen(FileName,"w");
	if(fp){
		fseek(fp,0,SEEK_SET);
	    	fwrite(&FCHK,4,1,fp);
				fwrite(&RoomHeader.bTileset,1,1,fp);
				fwrite(&RoomHeader.bBg0,1,1,fp);
				fwrite(&RoomHeader.bBg1,1,1,fp);
				fwrite(&RoomHeader.bBg2,1,1,fp);
				fwrite(&RoomHeader.lBg3,4,1,fp);
				fwrite(&RoomHeader.lForeground,4,1,fp); 
				fwrite(&RoomHeader.lLevelData,4,1,fp);
				fwrite(&RoomHeader.lBackLayer,4,1,fp);
				fwrite(&RoomHeader.lClipData,4,1,fp); 
				fwrite(&RoomHeader.lBackgroundTSA,4,1,fp);
				fwrite(&RoomHeader.bUnknown1,1,1,fp);
				fwrite(&RoomHeader.TransForeground,1,1,fp);
				fwrite(&RoomHeader.iSep1,2,1,fp);
				fwrite(&RoomHeader.lSpritePointer,4,1,fp); 
				fwrite(&RoomHeader.bSpriteIndex1,1,1,fp);
				fwrite(&RoomHeader.bEventSwitch,1,1,fp);
				fwrite(&RoomHeader.iSep2,2,1,fp);
				fwrite(&RoomHeader.lSpritePointer2,4,1,fp); 
				fwrite(&RoomHeader.bSpriteIndex2,1,1,fp);
				fwrite(&RoomHeader.bEventSwitch2,1,1,fp);
				fwrite(&RoomHeader.iSeperator,2,1,fp);
				fwrite(&RoomHeader.lSpritePointer3,4,1,fp); 
				fwrite(&RoomHeader.bSpriteIndex3,1,1,fp);
				fwrite(&RoomHeader.bMiniMapRoomX,1,1,fp);
				fwrite(&RoomHeader.bMiniMapRoomY,1,1,fp);
				fwrite(&RoomHeader.bEffect,1,1,fp);
				fwrite(&RoomHeader.bSceneryYPos,1,1,fp);
				fwrite(&RoomHeader.bNothing,1,1,fp);
				fwrite(&RoomHeader.bMusic,1,1,fp);
				fwrite(&RoomHeader.blank,1,1,fp);

		if(RoomHeader.bBg0){
			fputc(ThisForeground.X,fp);
			fputc(ThisForeground.Y,fp);
			fwrite(&ThisForeground.size,4,1,fp);
			fwrite(&ThisForeground.oSize,4,1,fp);
			fwrite(ThisForeground.TileBuf2D,1,(ThisForeground.X*ThisForeground.Y)*2,fp);
		}
		if(RoomHeader.bBg1){
			fputc(ThisLevelData.X,fp);
			fputc(ThisLevelData.Y,fp);
			fwrite(&ThisLevelData.size,4,1,fp);
			fwrite(&ThisLevelData.oSize,4,1,fp);
			fwrite(ThisLevelData.TileBuf2D,1,(ThisLevelData.X*ThisLevelData.Y)*2,fp);
		}
		if(RoomHeader.bBg2){
			fputc(ThisBackLayer.X,fp);
			fputc(ThisBackLayer.Y,fp);
			fwrite(&ThisBackLayer.size,4,1,fp);
			fwrite(&ThisBackLayer.oSize,4,1,fp);
			fwrite(ThisBackLayer.TileBuf2D,1,(ThisBackLayer.X*ThisBackLayer.Y)*2,fp);
		}
		fputc(ThisClipData.X,fp);
		fputc(ThisClipData.Y,fp);
		fwrite(&ThisClipData.size,4,1,fp);
		fwrite(&ThisClipData.oSize,4,1,fp);
		fwrite(ThisClipData.TileBuf2D,1,(ThisClipData.X*ThisClipData.Y)*2,fp);
		/*if(RoomHeader.lBg3){
			fputc(ThisBackground.X,fp);
			fputc(ThisBackground.Y,fp);
			fwrite(&ThisBackground.size,4,1,fp);
			fwrite(&ThisBackground.oSize,4,1,fp);
			for(i = 0; i<ThisBackground.oSize/2;i++)
			 fwrite(&ThisBackground.TileBuf2D[i],2,1,fp);
		}*/

		fputc(Enemy1.max,fp);
		for(i=0;i<Enemy1.max;i++){
			fputc(Enemy1.Enemies[i].Y,fp);
			fputc(Enemy1.Enemies[i].X,fp);
			fputc(Enemy1.Enemies[i].Creature,fp);
		}
		fputc(Enemy2.max,fp);
		for(i=0;i<Enemy2.max;i++){
			fputc(Enemy2.Enemies[i].Y,fp);
			fputc(Enemy2.Enemies[i].X,fp);
			fputc(Enemy2.Enemies[i].Creature,fp);
		}
		fputc(Enemy3.max,fp);
		for(i=0;i<Enemy3.max;i++){
			fputc(Enemy3.Enemies[i].Y,fp);
			fputc(Enemy3.Enemies[i].X,fp);
			fputc(Enemy3.Enemies[i].Creature,fp);
		}
        fwrite(&scroll.Room,1,1,fp);
  
        fwrite(&scroll.Number,1,1,fp);
        for(i = 0; i<scroll.Number+2;i++){
			fwrite(&scroll.Scrolls[i]. xStart,1,1,fp);
			fwrite(&scroll.Scrolls[i]. xEnd,1,1,fp);
			fwrite(&scroll.Scrolls[i]. yStart,1,1,fp);
			fwrite(&scroll.Scrolls[i]. yEnd,1,1,fp);
		}
		fclose(fp);
	} else {
		MessageBox(0,"Please enter a new file name","Error",MB_OK);
	}
	return 0;
}

int ImportRoom(){
	int i=0;
    char FileName[1024]={0};
	char FCHK[] ="DHFH\0";//FileHeader
	char CHKFILE[5]={0};
	FILE* fp=NULL;
	GBA.ReturnFileName("Please select a room\0*.dhr\0",FileName,512,0);
    if(FileName)
		fp = fopen(FileName,"r+");
	if(fp){
    fseek(fp,0,SEEK_SET);
    fread(&CHKFILE,4,1,fp);
   
		if(strcmp(CHKFILE,FCHK)==0){
		
		fread(&RoomHeader.bTileset,1,1,fp);
		fread(&RoomHeader.bBg0,1,1,fp);
		fread(&RoomHeader.bBg1,1,1,fp);
		fread(&RoomHeader.bBg2,1,1,fp);
		fread(&RoomHeader.lBg3,4,1,fp);
		fread(&RoomHeader.lForeground,4,1,fp); 
		fread(&RoomHeader.lLevelData,4,1,fp);
		fread(&RoomHeader.lBackLayer,4,1,fp);
		fread(&RoomHeader.lClipData,4,1,fp); 
		fread(&RoomHeader.lBackgroundTSA,4,1,fp);
		fread(&RoomHeader.bUnknown1,1,1,fp);
		fread(&RoomHeader.TransForeground,1,1,fp);
		fread(&RoomHeader.iSep1,2,1,fp);
		fread(&RoomHeader.lSpritePointer,4,1,fp); 
		fread(&RoomHeader.bSpriteIndex1,1,1,fp);
		fread(&RoomHeader.bEventSwitch,1,1,fp);
		fread(&RoomHeader.iSep2,2,1,fp);
		fread(&RoomHeader.lSpritePointer2,4,1,fp); 
		fread(&RoomHeader.bSpriteIndex2,1,1,fp);
		fread(&RoomHeader.bEventSwitch2,1,1,fp);
		fread(&RoomHeader.iSeperator,2,1,fp);
		fread(&RoomHeader.lSpritePointer3,4,1,fp); 
		fread(&RoomHeader.bSpriteIndex3,1,1,fp);
		fread(&RoomHeader.bMiniMapRoomX,1,1,fp);
		fread(&RoomHeader.bMiniMapRoomY,1,1,fp);
		fread(&RoomHeader.bEffect,1,1,fp);
		fread(&RoomHeader.bSceneryYPos,1,1,fp);
		fread(&RoomHeader.bNothing,1,1,fp);
		fread(&RoomHeader.bMusic,1,1,fp);
		fread(&RoomHeader.blank,1,1,fp);
		i=ftell(fp);
			if(RoomHeader.bBg0){
				ThisForeground.X=fgetc(fp);
				ThisForeground.Y=fgetc(fp);
				fseek(fp,0x40,SEEK_SET);
				ThisForeground.X=fgetc(fp);
				ThisForeground.Y=fgetc(fp);
				fread(&ThisForeground.size,4,1,fp);
				fread(&ThisForeground.oSize,4,1,fp);
				memset(&ThisForeground.TileBuf2D,0,0x20000);
				fread(&ThisForeground.TileBuf2D,1,(ThisForeground.X*ThisForeground.Y)*2,fp);
				
			}
			if(RoomHeader.bBg1){
				ThisLevelData.X=fgetc(fp);
				ThisLevelData.Y=fgetc(fp);
				fread(&ThisLevelData.size,4,1,fp);
				fread(&ThisLevelData.oSize,4,1,fp);
				memset(ThisLevelData.TileBuf2D,0,0x20000);
				fread(ThisLevelData.TileBuf2D,1,(ThisLevelData.X*ThisLevelData.Y)*2,fp);
			}
			if(RoomHeader.bBg2){
			    ThisBackLayer.X=fgetc(fp);
				ThisBackLayer.Y=fgetc(fp);
				fread(&ThisBackLayer.size,4,1,fp);
				fread(&ThisBackLayer.oSize,4,1,fp);
				memset(ThisBackLayer.TileBuf2D,0,0x20000);
				fread(ThisBackLayer.TileBuf2D,1,(ThisBackLayer.X*ThisBackLayer.Y)*2,fp);
			}
			ThisClipData.X=fgetc(fp);
			ThisClipData.Y=fgetc(fp);
			fread(&ThisClipData.size,4,1,fp);
			fread(&ThisClipData.oSize,4,1,fp);
			memset(ThisClipData.TileBuf2D,0,0x20000);
			fread(ThisClipData.TileBuf2D,1,(ThisClipData.X*ThisClipData.Y)*2,fp);
		/*	if(RoomHeader.lBg3){
				ThisBackground.X=fgetc(fp);
				ThisBackground.Y=fgetc(fp);
				fread(&ThisBackground.size,4,1,fp);
				fread(&ThisBackground.oSize,4,1,fp);
				ThisBackground.SetSize(ThisBackground.oSize/2);
				fread(ThisBackground.TileBuf2D,1,ThisBackground.oSize,fp);
			}*/
			Enemy1.max=fgetc(fp);
			for(i=0;i<Enemy1.max;i++){
				Enemy1.Enemies[i].Y=fgetc(fp);
				Enemy1.Enemies[i].X=fgetc(fp);
				Enemy1.Enemies[i].Creature=fgetc(fp);
			}
			Enemy2.max=fgetc(fp);
			for(i=0;i<Enemy2.max;i++){
				Enemy2.Enemies[i].Y=fgetc(fp);
				Enemy2.Enemies[i].X=fgetc(fp);
				Enemy2.Enemies[i].Creature=fgetc(fp);
			}
			Enemy3.max=fgetc(fp);
			for(i=0;i<Enemy3.max;i++){
				Enemy3.Enemies[i].Y=fgetc(fp);
				Enemy3.Enemies[i].X=fgetc(fp);
				Enemy3.Enemies[i].Creature=fgetc(fp);
			}
		}
		fread(&scroll.Room,1,1,fp);
  
        fread(&scroll.Number,1,1,fp);
        for( i = 0; i<scroll.Number+2;i++){
			fread(&scroll.Scrolls[i]. xStart,1,1,fp);
			fread(&scroll.Scrolls[i]. xEnd,1,1,fp);
			fread(&scroll.Scrolls[i]. yStart,1,1,fp);
			fread(&scroll.Scrolls[i]. yEnd,1,1,fp);
		}
	    fclose(fp);
		EditScrollData();
	  	ThisForeground.Dirty=1;
		ThisLevelData.Dirty=1;
		ThisBackLayer.Dirty=1;
		GetTileset(RoomHeader.bTileset);
		ThisForeground.BImage.Create(ThisForeground.X*16,ThisForeground.Y*16);
		ThisForeground.BImage.SetPalette(PcPalMem);
		ThisLevelData.BImage.Create(ThisLevelData.X*16,ThisLevelData.Y*16);
		ThisLevelData.BImage.SetPalette(PcPalMem);
		ThisBackLayer.BImage.Create(ThisBackLayer.X*16,ThisBackLayer.Y*16);
		ThisBackLayer.BImage.SetPalette(PcPalMem);
		
		DrawLevel();
	} else {
		MessageBox(0,"Please enter a new file name","Error",MB_OK);
	}
	

	return 0;
}
